/* $Id */
/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2
  (included in the RadioActive distribution in doc/GPL) as published by
  the Free Software Foundation.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "guppi-bonobo-view.h"
#include <libgnomeui/libgnomeui.h>
#include <guppi-plot-state.h>
#include <guppi-plot-element.h>

void guppi_bonobo_view_refresh(GuppiBonoboView *view)
{
}

static GtkWidget*
view_new(GuppiBonoboView *view_data)
{
  GtkWidget *widget;

  gtk_widget_push_visual(gdk_rgb_get_visual());
  gtk_widget_push_colormap(gdk_rgb_get_cmap());
  widget = guppi_plot_view_new(view_data->obj->state);
  gtk_widget_pop_colormap();
  gtk_widget_pop_visual(); 
  
  gtk_widget_show_all(widget);

  return widget;
}

static void
view_delete(BonoboView *view, GuppiBonoboView *view_data)
{
  /*  gtk_object_unref(GTK_OBJECT(view_data->widget)); */
  g_free(view_data);
}

static void
view_activate_cb(BonoboView *view, gboolean activate, gpointer data)
{
  GuppiBonoboView *view_data;
  GuppiObject *obj;
  int i;

  bonobo_view_activate_notify(view, activate);
  view_data = (GuppiBonoboView *) data;
  obj = view_data->obj;

  i = guppi_plot_state_element_count(obj->state);
  while (i-- > 0) {
    GuppiPlotElement *element;
    element = guppi_plot_state_get_element(obj->state, i);
    if (activate)
      guppi_plot_element_edit(element);
  }
}

BonoboView*
guppi_bonobo_view_factory(BonoboEmbeddable *bonobo_embeddable,
			  const Bonobo_ViewFrame view_frame,
			  void *data)
{
  BonoboView *view;
  GuppiObject *obj = (GuppiObject*) data;
  GuppiBonoboView *view_data = g_new(GuppiBonoboView, 1);
    
  view_data->obj = obj;
  view_data->widget = view_new(view_data);
    
  view = bonobo_view_new(view_data->widget);
  view_data->view = view;
  bonobo_view_set_view_frame(view, view_frame);
    
  gtk_object_set_data(GTK_OBJECT (view), "view_data", view_data);
  
  gtk_signal_connect(GTK_OBJECT (view), "destroy",
		     GTK_SIGNAL_FUNC(view_delete),
		     view_data);
  
  gtk_signal_connect (GTK_OBJECT (view), "activate",
		      GTK_SIGNAL_FUNC(view_activate_cb),
		      view_data);
  
  return (view);
}
